package io.zipcoder.interfaces;

public enum Educator implements Teacher{
        KRIS(40,"Kris Younger"),
        FROILAN(41, "Froilan"),
        DOLIO(42, "Dolio"),
        LEON(43, "Leon"),
        WILLHEM(44, "Willhem"),
        NHYU(45, "Nhyu");

    private int id;
    private String name;
    private double timeWorked;

    Educator(int id, String name){
        this.id = id;
        this.name = name;
        this.timeWorked = 0;
    }

    public void teach(Learner learner, double numberOfHours) {
        learner.learn(numberOfHours);
        setTimeWorked(getTimeWorked() + numberOfHours);
    }

    public void lecture(Learner[] learners, double numberOfHours) {

        for (Learner learner : learners) {
            double numberOfHoursPerLearner = (numberOfHours / learners.length);
            learner.learn(numberOfHoursPerLearner);
        }
        setTimeWorked(getTimeWorked() + numberOfHours);

    }

    public double getTimeWorked() {
        return timeWorked;
    }

    public void setTimeWorked(double timeWorked) {
        this.timeWorked = timeWorked;
    }

    public int getId() {
        return id;
    }

    public String getName() {
        return name;
    }
}
