package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class InstructorTest {

    Instructor instructor;
    @Before
    public void setup(){
        instructor = new Instructor();
    }

    @Test
    public void testTeacherImpl(){
        Teacher instructor = new Instructor();
        Assert.assertTrue(instructor instanceof Teacher);
    }

    @Test
    public void testInheritance(){
        Person instructor = new Instructor();
        Assert.assertTrue(instructor instanceof Person);
    }

    @Test
    public void testTeach(){
        Student student = new Student();
        int expected = 5;
        instructor.teach(student, 5);
        int actual = student.getTotalStudyTime();
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testLecture(){
        int expected = 2;
        Student student1 = new Student();
        Student student2 = new Student();
        Student student3 = new Student();

        Learner[] learners = new Student[]{student1,student2,student3};

        instructor.lecture(learners, 6);
        int actual = student1.getTotalStudyTime();
        Assert.assertEquals(expected, actual);
    }


}
