package io.zipcoder.interfaces;

import io.zipcoder.interfaces.People.subClass;
import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;

public class PeopleTest {

    @Test
    public void testAdd(){
        People people = new subClass();
        Person person = new Person();
        people.add(person);
        ArrayList<Person> personList = people.getPersonList();

        Assert.assertTrue(person.equals(personList.get(0)));
    }

    @Test
    public void testRemoveByPerson(){
        Person person = new Person();
        People people = new subClass();
        people.add(person);
        people.remove(person);

        Assert.assertEquals(0,  people.personList.size());
    }

    @Test
    public void testRemoveById(){
        Person person = new Person();
        People people = new subClass();
        people.add(person);
        people.removeById(1);
        Assert.assertEquals(0, people.personList.size());
    }

    @Test
    public void testFindById(){
        Person person = new Person(1,"xyz");
        People people = new subClass();
        people.add(person);
        Person actualPerson = people.findById(1);
        Assert.assertEquals(person, actualPerson);
    }

    @Test
    public void testGetArray(){
        boolean expected = true;
        Person person = new Person();
        Person person2 = new Person();
        People people = new subClass();
        people.add(person);
        people.add(person2);
        boolean actual = true;
        Person[] personArr = people.getArray();
        ArrayList<Person> list = people.getPersonList();

        for(int i =0;i<list.size();i++){
            if(!personArr[i].equals(list.get(i)))
                actual = false;
        }
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void testRemoveAll(){
        Person person = new Person();
        Person person2 = new Person();
        People people = new subClass();
        people.add(person);
        people.add(person2);

        people.removeAll();

        Assert.assertEquals(0,people.personList.size());
    }
}
